; -----------------------------------------
; CPP9610VB10 CNC-Frse
; -----------------------------------------

	.include "ram.inc"
	.include "m16def.inc"
	.include "allgdef.inc"

	.cseg

   	jmp		start
   	
		
	.org	0x08
	jmp		tim2int
	.org	0x12
   	jmp		tim0int

	.org	0x100

start:

; RAM lschen
	ldi		zh,high(SRAM_START)
	ldi		zl,low(SRAM_START)
	ldi		acc2,high(clrende)
	ldi		acc3,low(clrende)
	clr		acc
ramclr:
	st		z+,acc
	cp		acc3,zl
	cpc		acc2,zh
	brcc	ramclr
	
; Stack
	ldi		r16,low(ramend)
	out		spl,r16
	ldi		r16,high(ramend)
	out		sph,r16

; Ports einstellen
; PA: 0,1,2,3=ADW 4,5,6,7 =Inp ohne PU
	ldi		r16,0b00000000
	out		ddra,r16
	ldi		r16,0b00000000
	out		porta,r16
; PB: 0,1,2,3,4,5,6 = Inp ohne PU, 7=Res	
	ldi		r16,0b00000001
	out		ddrb,r16
	ldi		r16,0b00000000
	out		portb,r16
; PC: 0=SCL 1=SDA 2,3,4,5=JTAG 6 =Inp ohne PU, 7 = Outp	
	ldi		r16,0b00010001
	out		ddrc,r16
	ldi		r16,0b00111100
	out		portc,r16
; PD: 0 = Inp ohne PU, 1,2,3,4,5,6,7=Outp	
	ldi		r16,0b11111110
	out		ddrd,r16
	ldi		r16,0b00000000
	out		portd,r16
  
; Register lschen
    clr   sollzlrlx
    clr   sollzlrhx
    clr   sollzlrly
    clr   sollzlrhy
    clr   sollzlrlz
    clr   sollzlrhz
    clr   zlrlx
    clr   zlrhx
    clr   zlrly
    clr   zlrhy
    clr   zlrlz
    clr   zlrhz
    clr   merker
    clr   tasten
    ldi     acc,drzhalt
    sts     neuedrzx,acc
    sts     neuedrzy,acc
    sts     neuedrzz,acc
    sts     altedrzx,acc
    sts     altedrzy,acc
    sts     altedrzz,acc
  
; Timer0, Takt:
; TCCR0 0000$0011 = SysClock/64 mal 125(Timer-berlauf) = 500us
; TCCR0 0000$0010 = SysClock/8 mal 125(Timer-berlauf) = 62.5us
; TCCR0 0000$0001 = SysClock/1 mal 256(Timer-berlauf) = 16us
; Timer0, Interrupt TIMSK = 0000$0001
	ldi		acc,0b00000010    
	out		TCCR0,acc
	ldi		acc,0b00000001
	out		TIMSK,acc

; PWM-Ausgang: T2  / OC2 (PD7) fr Pumpe, Interrupt fr Soft-Timer

	ldi		r16,0b01101010	; PWM schnell, Takt / 8 = 0,5us
	out		tccr2,r16
	ldi		r16,0			; PWM-Startwert
	out		ocr2,r16

; Timer-Interrupt
	ldi		acc,0b01000001
	out		TIMSK,acc

; Interrupt

	sei

;--------------------------------------------------
; HP  *********************************************
;--------------------------------------------------

hp:
    call    betrieb
    call    pumpcon
    call    timer
    call    anainput
    call    input
    call    refcon
    call	ledcon
    jmp     hp

;--------------------------------------------------
; TIMxINT
;--------------------------------------------------

; wird alle 50us aufgerufen
tim0int:
	in		acc4,sreg
    push    acc4
    ldi     acc4,156
    out     TCNT0,acc4
; X ------------------------
; X-Zlr = 1? dann Impuls =1 ausgeben
    tst     zlrhx
    brne    tim0intx1
    cpi     zlrlx,1
    brne    tim0intx1    
    sbi     portd,clk_x
    rjmp    tim0intX2
; Impuls = 0
tim0intx1:         
    cbi     portd,clk_x
    mov     acc4,zlrhx
    or      acc4,zlrlx
    brne    tim0intx2
    mov     zlrlx,sollzlrlx
    mov     zlrhx,sollzlrhx
    rjmp    tim0inty
tim0intx2:
    ldi     acc4,1
    sub     zlrlx,acc4
    clr     acc4
    sbc     zlrhx,acc4
; Y -------------------------
; Y-Zlr = 1? dann Impuls =1 ausgeben
tim0intY:
    tst     zlrhy
    brne    tim0inty1
    cpi     zlrly,1
    brne    tim0inty1    
    sbi     portd,clk_y
    rjmp    tim0inty2
; Impuls = 0
tim0inty1:         
    cbi     portd,clk_y
    mov     acc4,zlrhy
    or      acc4,zlrly
    brne    tim0inty2
    mov     zlrly,sollzlrly
    mov     zlrhy,sollzlrhy
    rjmp    tim0intz
tim0inty2:
    ldi     acc4,1
    sub     zlrly,acc4
    clr     acc4
    sbc     zlrhy,acc4
; Z -------------------------
; Z-Zlr = 1? dann Impuls =1 ausgeben
tim0intZ:
    tst     zlrhz
    brne    tim0intz1
    cpi     zlrlz,1
    brne    tim0intz1    
    sbi     portd,clk_z
    rjmp    tim0intz2
; Impuls = 0
tim0intz1:         
    cbi     portd,clk_z
    mov     acc4,zlrhz
    or      acc4,zlrlz
    brne    tim0intz2
    mov     zlrlz,sollzlrlz
    mov     zlrhz,sollzlrhz
    rjmp    tim0intret
tim0intz2:
    ldi     acc4,1
    sub     zlrlz,acc4
    clr     acc4
    sbc     zlrhz,acc4
    
tim0intret:
    pop     acc4    
    out		sreg,acc4
	reti


; wird alle 2*256=128us aufgerufen

tim2int:
	in		acc4,sreg
	inc		softtimer
	out		sreg,acc4
	reti

dummy:
	reti
		
; ------------------------------------------------
	
.include	"pumpcon.asm"
.include	"anainput.asm"
.include	"diverse.asm"
.include	"timer.asm"
.include	"input.asm"
.include	"refcon.asm"
.include	"joystick.asm"
.include	"betrieb.asm"

