 ;--------------------------------------------------
; TIMER
;--------------------------------------------------

timer:
	cli
	mov		acc,softtimer		; 128us-Takt
	subi	acc,78
	brcc	timer0
	sei
	ret
timer0:
	mov		softtimer,acc
	sei
; 128*78= 10ms
timer1:
	lds		acc,reftim
	tst		acc
	breq	timerX
	dec		acc
	sts		reftim,acc
    sbrs    tasten,schalterhand   ; Handbedienung?
    ret                           ; nein

; Takte und Richtung bergeben und die Endschalter berwachen
; Eingang: (D)neuedrz?, (D)altedrz?
; Augang: port fr DIR gesetzt und (D)sollzlr?

; 1.) X
timerX:
    lds     acc,neuedrzx
    cpi     acc,145         ; >= 145?
    brcs    timerx2         ; nein
    sbrc    endschalter,endeXR  ; ES rechts?
    jmp     timerx3             ; nein
    lds     acc,altedrzx
    call    bremsemax           ; acc -> acc
    jmp     timerx5
timerx2:
    cpi     acc,111         ; <= 110?
    brcc    timerx3         ; nein
    sbrc    endschalter,endeXL  ; ES links?
    jmp     timerx3             ; nein
    lds     acc,altedrzx
    call    bremsemin           ; acc -> acc
    jmp     timerx5
timerx3:
	lds		acc2,neuedrzx
    lds     acc,altedrzx
    cp      acc2,acc        ; neue grer als alte?
    breq    timerx5        ; identisch!
    brcs    timerx4        ; ja
    inc     acc
    rjmp    timerx5
timerx4:
    dec     acc
timerx5:
    sts     altedrzx,acc
    call    holedrehzahl            ; acc 0...255  -> acc 0..110 und C
    brcs    timerx6
    sbi     portd,dir_x
    jmp     timerx7
timerx6:
    cbi     portd,dir_x
timerx7:
    call    holezlrwert             ;  acc -> acc2(HW), acc(NW)
    cli
    mov     sollzlrlx,acc
    mov     sollzlrhx,acc2
    sei
    
; 2.) Y
timery:
    lds     acc,neuedrzy
    cpi     acc,145         ; >= 145?
    brcs    timery2         ; nein
    sbrc    endschalter,endeYH  ; ES hinten?
    jmp     timery3             ; nein
    lds     acc,altedrzy
    call    bremsemax           ; acc -> acc
    jmp     timery5
timery2:
    cpi     acc,111         ; <= 110?
    brcc    timery3         ; nein
    sbrc    endschalter,endeYV  ; ES vorn?
    jmp     timery3             ; nein
    lds     acc,altedrzy
    call    bremsemin           ; acc -> acc
    jmp     timery5
timery3:
    lds     acc2,neuedrzy
    lds     acc,altedrzy
    cp      acc2,acc        ; neue grer als alte?
    breq    timery5        ; identisch!
    brcs    timery4        ; ja
    inc     acc
    rjmp    timery5
timery4:
    dec     acc
timery5:
    sts     altedrzy,acc
    call    holedrehzahl            ; acc 0...255  -> acc 0..110 und C
    brcs    timery6
    sbi     portd,dir_y
    rjmp    timery7
timery6:
    cbi     portd,dir_y
timery7:
    call    holezlrwert             ;  acc -> acc,acc2
    cli
    mov     sollzlrly,acc
    mov     sollzlrhy,acc2
    sei
    
; 3.) Z
timerZ:
    lds     acc,neuedrzz
    cpi     acc,145         ; >= 145?
    brcs    timerz2         ; nein
    sbrc    endschalter,endeZO  ; ES oben?
    jmp     timerz3             ; nein
    lds     acc,altedrzz
    call    bremsemax           ; acc -> acc
    jmp     timerz5
timerz2:
    cpi     acc,111         ; <= 110?
    brcc    timerz3         ; nein
    sbrc    endschalter,endeZU  ; ES unten?
    jmp     timerz3             ; nein
    lds     acc,altedrzz
    call    bremsemin           ; acc -> acc
    jmp     timerz5
timerz3:
    lds     acc2,neuedrzz
    lds     acc,altedrzz
    cp      acc2,acc            ; neue grer als alte?
    breq    timerz5             ; identisch!
    brcs    timerz4             ; ja
    inc     acc
    rjmp    timerz5
timerz4:
    dec     acc
timerz5:
    sts     altedrzz,acc
    call    holedrehzahl            ; acc 0...255  -> acc 0..110 und C
    brcs    timerz6
    sbi     portd,dir_z
    rjmp    timerz7
timerz6:
    cbi     portd,dir_z
timerz7:
    call    holezlrwert             ;  acc -> acc,acc2
    cli
    mov     sollzlrlz,acc
    mov     sollzlrhz,acc2
    sei
    ret
    
; Bremsen
; BREMSEMIN 0...110 wird erhht, (0 = maximale Drehzahl)
bremsemin:
    cpi     acc,4
    brcc    bmin1
    ldi     acc,5
    ret
bmin1:
    cpi     acc,10
    brcc    bmin2
    ldi     acc,11
    ret
bmin2:
    cpi     acc,30
    brcc    bmin3
    ldi     acc,31
    ret
bmin3:
    cpi     acc,60
    brcc    bmin4
    ldi     acc,61
    ret
bmin4:
    ldi     acc,111
    ret

; BREMSEMAX 145...255 wird vermindert, (255 = maximale Drehzahl)
bremsemax:
    cpi     acc,250
    brcs    bmax1
    ldi     acc,249
    ret
bmax1:
    cpi     acc,245
    brcs    bmax2
    ldi     acc,244
    ret
bmax2:
    cpi     acc,225
    brcs    bmax3
    ldi     acc,224
    ret
bmax3:
    cpi     acc,195
    brcs    bmax4
    ldi     acc,194
    ret
bmax4:
    ldi     acc,144
    ret
             
